WITH   Ada.Unchecked_Conversion ;
WITH   Interfaces.C ;
WITH   System ;
WITH   Win32 ;
WITH   Win32.Crt.Strings ;
WITH   Win32.Windef ;
WITH   Win32.Wingdi ;
WITH   Win32.Winuser ;

PACKAGE BODY   CharTb21_Pkg  IS

   FUNCTION   CP   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPCSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPCSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CP;

   FUNCTION   CPS   ( I_Str : Win32.CHAR_Array )  RETURN  Win32.LPSTR  IS
      FUNCTION   UC  IS
         new Ada.Unchecked_Conversion ( System.Address , Win32.LPSTR );
   BEGIN
      RETURN  UC ( I_Str(I_Str'First)'Address );
   END CPS;

   USE TYPE   Win32.CHAR_Array ;      --- To get "&"

   Nul : Win32.Char RENAMES Win32.Nul ;

   IgnoredI : Win32.INT ;
   IgnoredP : Win32.PSTR ;

   C_MainPMTitle : CONSTANT Win32.CHAR_Array := "Information"  &  Nul ;

   L_Buffer : ALIASED Win32.CHAR_Array(0..4096);
   L_Buf01z : ALIASED Win32.CHAR_Array(0..1);

   PROCEDURE   ShowCharTb21  IS
   BEGIN
      L_Buffer(0) := Nul ;

      L_Buf01z(1) := Nul ;

      ----- LOOP , On each char
      FOR i in 0..255 LOOP
         ----- Write char  ( Ignoring problem chars )
         IF (i = 0) or (i = 9) or (i = 10) or (i = 13)
         THEN
            L_Buf01z(0) := '-' ;
         ELSE
            L_Buf01z(0) := Win32.Char(Character'Val(i));
         END IF;
         IgnoredP := Win32.Crt.Strings.StrCat ( CPS(L_Buffer) , CP(L_Buf01z) );
      END LOOP;

      IgnoredI := Win32.Winuser.MessageBox ( System.Null_Address
                                           , CP(L_Buffer)
                                           , CP(C_MainPMTitle)
                                           , Win32.Winuser.MB_OK or Win32.Winuser.MB_ICONEXCLAMATION );
   END ShowCharTb21;
END CharTb21_Pkg;
